VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "CGIProcessor"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
'CGIGateway.DLL 1.0 - created on 8 Sept. 2005
'writen by: Michael Reep (somenon2@yahoo.com, somenon@hotmail.com) just for fun
'use this code and parts of it freely, however if you use the entire package in your
'project, please document author where appropriate
'
'If you make any updates or changes to this code, please email me at above email address
'
'Borrowed Source Code functions/modules and authors:
'
'ExecApp Module (function: ExecuteApp) and declarations: Unknown
'This function is located at: http://www.developersdomain.com/vb/articles/redirectpipe.htm
'
'GenNum function: Konstantinos Fryganas
'This function is located at: http://www.planet-source-code.com/vb/scripts/ShowCode.asp?txtCodeId=53995&lngWId=1
'
'This DLL works great with myWebServer 1.0 (with a few modifications of course) by: Chris Goodsell
'This code package is located at: http://www.freevbcode.com/ShowCode.asp?ID=4415

Option Explicit
'we don't want any loose variables floating around do we?


Property Let ServerSoftware(ByVal strData1 As String)
'this property is will become the SERVER_SOFTWARE environment variable
'we also set bolServer_Software = True so that the Execute function will know
'that this property has been set

strServer_Software = strData1
bolServer_Software = True
End Property

Property Get ServerSoftware() As String
'this property GET is merely used for the retrieval of the
'ServerSoftware property by the webserver
ServerSoftware = strServer_Software

End Property

Public Function ClearHandlers()
'this function clears the script handlers that have been defined

ReDim strFileExt(0)
ReDim strFileHandler(0)


End Function

Public Function remHandlers(strExtension As String) As Boolean
'this function just removes a handler, this is usefull so that
'you don't have to clear the handlers and reset them just to remove one
'the reason we do this, is so that if a client is requesting a page during a handler
'update, they will still get their page, and the handler will still exist within the array
Dim intHandlerSpot As Integer

    For i = 0 To intHandlerCount - 1
    

        If InStr(1, UCase(strFileExt), UCase(strExtension)) > 0 Then
        'we found the file extension, now we set it as blank
        'and set the handler index to intHandlerSpot, so we can shrink the array back down
        strFileExt(i) = ""
        strFileHandler(i) = ""
        intHandlerSpot = i
        Exit For
        End If
        
    Next i



    For i = intHandlerSpot To intHandlerCount - 1
    'we set the next index's value to this index's value, and knock off an index on the end
    'of course, we start at the blank index
    
        strFileExt(i) = strFileExt(i + 1)
        strFileHandler(i) = strFileHandler(i + 1)
    
    
    Next i


    'now we reduce the handler count
    intHandlerCount = intHandlerCount - 1
    
    'and we shrink the array minus one
    ReDim Preserve strFileExt(intHandlerCount)
    ReDim Preserve strFileHandler(intHandlerCount)
    

    


End Function

Public Function setHandlers(strExtension As String, strExecuteable As String) As Boolean

If Not strExtension = "" And Not strExecuteable = "" Then
    'ok, we have good values for each one


    intHandlerCount = intHandlerCount + 1
    'increase the handlercount value
    
    'now increase the array by one
    ReDim Preserve strFileExt(intHandlerCount)
    ReDim Preserve strFileHandler(intHandlerCount)
    
    
    'now set the last index in the array to the new values
    strFileExt(intHandlerCount - 1) = UCase(strExtension)
    strFileHandler(intHandlerCount - 1) = UCase(strExecuteable)
    


    bolSetHandlers = True
    
    setHandlers = True
Else
    setHandlers = False
End If



End Function

Public Function setHeader(strData As String) As String

'this is the function that gets the user's header request data and sets it to
'the variables, this function will return a number of error codes, very useful for
'debugging. See below for error codes and definitions

Dim bolPreset_Script_Name As Boolean
Dim strFailReason As String, strWarnings As String
Dim strFileLine As String

strWarnings = ""
strFailReason = ""

If bolServer_Software = False Then
'property not set
strFailReason = strFailReason & "L1,"
Log_Entry "L1 - ServerSoftware Property not set for " & strScript_Name
End If






If bolSetHandlers = False Then
'setHandlers function has not been run yet, atleast once
'return the fail reason code F1
strFailReason = strFailReason & "F1,"
Log_Entry "F1 - setHandlers not executed prior to calling script: " & strScript_Name
End If

If bolScript_Filename = False Then
'function not executed
strFailReason = strFailReason & "F2,"
Log_Entry "F2 - setLocalFilePath not executed prior to calling script: " & strScript_Name
End If

If bolRemote_Addr = False Then
'function not executed
strFailReason = strFailReason & "F3,"
Log_Entry "F3 - setRemUserIP not executed prior to calling script: " & strScript_Name
End If


'check to see if this is a vaid header, currently this dll cannot support the
'PUT request (for file uploading). I have only worked enough to allow GET and POST
'if someone would like to build-in PUT support, just add that here to keep from erroring out

If Not (InStr(1, strData, "GET") > 0 Or InStr(1, strData, "POST") > 0) Then
strFailReason = strFailReason & "A1,"
Log_Entry "A1 - GET or POST method not found in the header for script: " & strScript_Name
End If

    If Not strFailReason = "A1," Then
    'get file request line if there's a post or get statement
    Dim intLineStart As Integer, intLineEnd As Integer
    
        If InStr(1, UCase(strData), "POST") > 0 Then
        'it's a post request
        
        strRequest_Method = "POST"
        'set this here, keep from having to re-test the line later
        
        'start capturing at post statement and go until the next carriage return
        intLineStart = InStr(1, UCase(strData), "POST")
        intLineEnd = InStr(intLineStart + 1, strData, vbCrLf)
        
        'now set the string data
        strFileLine = Mid(strData, intLineStart, intLineEnd - intLineStart)
        
        
        
        Else
        'it's a get request
        
         strRequest_Method = "GET"
        'set this here, keep from having to re-test the line later
        
        'start capturing at get statement and go until the next carriage return
        intLineStart = InStr(1, UCase(strData), "GET")
        intLineEnd = InStr(intLineStart + 1, strData, vbCrLf)
        
        'now set the string data
        strFileLine = Mid(strData, intLineStart, intLineEnd - intLineStart)
        
        
        
        
        End If
        
        
        
        'now that we have the file request line, check to see if there is a script file
        'that has been defined in the SetHandlers function (ex: .php,.cgi,etc.)
        Dim bolGoodFileExt As Boolean
        bolGoodFileExt = False
        
        For i = 0 To intHandlerCount - 1
        
            If InStr(1, UCase(strFileLine), UCase(strFileExt(i))) > 0 Then
            'file extension is in this line, we can proceed
            bolGoodFileExt = True
            Exit For
            End If
        
        Next i
        
        
        If bolGoodFileExt = False Then
        strFailReason = strFailReason & "A2,"
        Log_Entry "A2 - Either no script file was requested in the file header (after GET or POST), or there wasn't a valid extension for scripting: " & strScript_Name
        End If
        
        
    End If


If Mid(strData, 4, 3) = " / " Or Mid(strData, 5, 3) = " / " Then
strFailReason = strFailReason & "A2,"
Log_Entry "A2 - No script file was requested, will try to get it from setLocalFilePath: " & strScript_Name
End If




            'if there is not file, we can check to see if the server sent the name of the file
            'in strScript_Filename
            
            If InStr(1, strFailReason, "A2,") > 0 Then
            'yes we have failed, see if we got passed a local filename
            
                If Not strScript_Filename = "" Then
                'we can use this as our filename
            
                    bolPreset_Script_Name = True
                    strScript_Name = "/" & Right(strScript_Filename, Len(strScript_Filename) - InStrRev(strScript_Filename, "\", Len(strScript_Filename)))
                    
                    'now take out the A2 error
                    strFailReason = Replace(strFailReason, "A2,", "")
                    Log_Entry "A2 - CORRECTED, found the script file from setLocalFilePath: " & strScript_Name
            
                End If
            
            End If


'now we need to check to see that all the needed data has been sent in the request header
'and set error codes if they have not been

If InStr(1, strData, "HTTP/") <= 0 Then
strFailReason = strFailReason & "A3,"
Log_Entry "A3 - No HTTP Version included in the request header (first line): " & strScript_Name
End If

If InStr(1, UCase(strData), "ACCEPT: ") <= 0 Then
strFailReason = strFailReason & "A4,"
Log_Entry "A4 - No ACCEPT data was included in the request header: " & strScript_Name
End If

If InStr(1, UCase(strData), "ACCEPT-LANGUAGE: ") <= 0 Then
strFailReason = strFailReason & "A5,"
Log_Entry "A5 - No ACCEPT-LANGUAGE data was included in the request header: " & strScript_Name
End If

If InStr(1, UCase(strData), "ACCEPT-ENCODING: ") <= 0 Then
strFailReason = strFailReason & "A6,"
Log_Entry "A6 - No ACCEPT-ENCODING data was included in the request header: " & strScript_Name
End If

If InStr(1, UCase(strData), "USER-AGENT: ") <= 0 Then
strFailReason = strFailReason & "A7,"
Log_Entry "A4 - No USER-AGENT data was included in the request header: " & strScript_Name
End If

If InStr(1, UCase(strData), "HOST: ") <= 0 Then
strFailReason = strFailReason & "A8,"
Log_Entry "A4 - No HOST data was included in the request header: " & strScript_Name
End If


    If InStr(1, UCase(strData), "POST") > 0 Then
    'it is a post request, make sure post data is available
    
    
    
        If InStr(1, UCase(strData), "REFERER: ") <= 0 Then
        strFailReason = strFailReason & "P1,"
        Log_Entry "P1 - (Post Request), No REFERER data was included in the request header: " & strScript_Name
        End If
    
        If InStr(1, UCase(strData), "CONTENT-TYPE: ") <= 0 Then
        strFailReason = strFailReason & "P2,"
        Log_Entry "P1 - (Post Request), No CONTENT-TYPE data was included in the request header: " & strScript_Name
        End If
        
        If InStr(1, UCase(strData), "CONTENT-LENGTH: ") <= 0 Then
        strFailReason = strFailReason & "P3,"
        Log_Entry "P1 - (Post Request), No CONTENT-LENGTH data was included in the request header: " & strScript_Name
        End If
    
    
    End If
    
    
    
    'if we have errors, then we ened to exit the function and return the error codes
    If Not strFailReason = "" Then
    strSetHeaderErrors = strFailReason
    setHeader = strFailReason
    Log_Entry "Too many errors in the request for file: " & strScript_Name & " exiting..."
    Log_Entry "Error Codes: " & strFailReason
    Exit Function
    End If
    

    Dim strHeaderParts() As String
    'we're going to divide the header up into an array, by line, for easier access.
    'we can just search through the array till we find what we need to work with
    
    strHeaderParts = Split(strData, vbCrLf)
    'for post requests, ther will be a blank index, because of the double carriage return
    'before the post data
    
    
    'at this point, we set the environment variables needed to execute the interpreter
    'strServer_Software, strServer_Name and strServer_Port are already set as needed before "SetHeader"
    'strRequest_Method was set earlier when we were testing for request methods, to see if an actual
    'file had been called
    'strScript_Filename was set in the "setLocalFilePath" function
    'strRemote_Addr was set in the "SetRemoteUserIP" function
    strGateway_Interface = "CGI/1.1"
    strServer_Protocol = "HTTP"
    
    
    'find post data, it will be after a blank index
    For i = 0 To UBound(strHeaderParts)
    
        If strHeaderParts(i) = "" Then
        strPost_Data = strHeaderParts(i + 1)
        Exit For
        End If
        
    Next i
    
    
    
    Dim strLine1 As String
    Dim strEnvVar As String, strValue As String
    Dim intColon As Integer
    
    
    'now we find out the script name and query string
    'first we stirp the get and post statements
    'then the http version
    strLine1 = strHeaderParts(0)
    strLine1 = Replace(strLine1, "GET ", "")
    strLine1 = Replace(strLine1, "POST ", "")
    strLine1 = Left(strLine1, InStr(1, strLine1, "HTTP/") - 1)
    
    
    'now we have just the script virutal path and query string, if any
    If InStr(1, strLine1, "?") > 0 Then
    'there's a query string attached
    
        'check to see if we have already set the script name, from strscript_filename
        'if so, use that instead of what we have here
        If bolPreset_Script_Name = False Then
            strScript_Name = Left(strLine1, InStr(1, strLine1, "?") - 1)
        End If
        
    strQuery_String = Right(strLine1, Len(strLine1) - InStr(1, strLine1, "?"))
    
    Else
    'there's no query string
    
        'if there's no script name, use the preset one from strscript_filename
        If bolPreset_Script_Name = False Then
            strScript_Name = strLine1
        End If
    
    End If
    
    
    'now we loop through the header lines, and pick out parts we need.
    'this makes for an easy code update. If you need an additional item here
    'just use the item name in all CAPS in the select case section.
    For i = 0 To UBound(strHeaderParts)
        strEnvVar = ""
        strValue = ""
        intColon = 0
    
        intColon = InStr(1, strHeaderParts(i), ":")
    
        
        If intColon <= 0 Then
        'if there's no colon (:) then we don't use an environment variable here
            strEnvVar = ""
        
        Else
        'there is a colon, we need to split the name and the value
    
            strEnvVar = UCase(Mid(strHeaderParts(i), 1, intColon - 1))
            strValue = Mid(strHeaderParts(i), intColon + 2, Len(strHeaderParts(i)) - intColon + 1)


            'ok look at the variable name and decide what to do with it
            Select Case strEnvVar
            
            Case "REFERER", "REFERRER"
            strHTTP_Referer = strValue
            
            Case "USER-AGENT"
            strHTTP_User_Agent = strValue
            
            Case "CONTENT-LENGTH"
            strContent_Length = strValue
            
            Case "CONTENT-TYPE"
            strContent_Type = strValue
            
            Case "COOKIE"
            strHTTP_Cookie = strValue
            
            Case "HOST"
            
            strHTTP_Host = strValue
            
                'ok here, we have the host data, if you are using a port other than 80
                'it will be formatted as this: hostname:port, if you are using port 80,
                'there will be no colon, so we'll use port 80 in server_port
                
                
                If InStr(1, strValue, ":") > 0 Then
                'there is a colon, now we get the server_name and server_port
                strServer_Port = Right(strValue, Len(strValue) - InStr(1, strValue, ":"))
                strServer_Name = Left(strValue, InStr(1, strValue, ":") - 1)
                Else
                'there's no colon, set server_port to 80 and get the server_name
                strServer_Port = "80"
                strServer_Name = strValue
                End If
                
            Case Else
            'everything else - nothing happens to

            End Select

        End If

    Next i
    
    
    
    'and that's it, now we have to reset our boolean test variables back to false
    'and also reset the failreason codes so that the next time this funtion is execute
    'we won't get any possible leftover data from the last execution
    strFailReason = ""
    bolServer_Software = False
    bolSetHandlers = False
    bolScript_Filename = False
    bolRemote_Addr = False
    bolGoodFileExt = False
    bolPreset_Script_Name = False
    
    


'fail reasons:

' Letter "L" error codes are for properties not set prior to executing a script
' Note: ALL properties can be set a load-time, and re-set if a settting was to change
'L1 - The property "ServerSoftware" was not set. This is a string value, formatted as such (SoftwareName/1.0)

' Letter "F" error codes are for functions not execute prior to executing a script
'F1 - the function "SetHandlers" has not been executed prior to running a script
'     the SetHandlers function is ran at load time, and tells the gateway
'     what script interpreters you have loaded (ex: .php, c:\php\php.exe)
'F2 - the function "SetLocalFilePath" was not executed. This function tells the interpreter
'     the physical location of the script file on the local machine (c:\folder\folder\script.php)
'     This function is executed every time a script is called, it needs to be executed before
'     the "SetHeader" function. It is the responsibility of the webserver software to provide this
'     information.
'F3 - the function "SetRemoteUserIP" was not executed.

' Letter "A" error codes are for All (or general) errors, not specific to request type
'A1 - GET or POST not present
'A2 - No Script File present in GET or POST statement
'A3 - No HTTP Version specified (HTTP/1.1)
'A4 - No "Accept: " filetypes specified (*/*)
'A5 - No "Accept-Language: " specified (en-us)
'A6 - No "Accept-Encoding: " specified (gzip, deflate)
'A7 - No "User-Agent: " specified (Mozilla 4.0)
'A8 - No "Host: " specified (localhost)

' Letter "P" error codes are for POST request header type errors
'P1 - No "Referer: " specified, page from which the data was posted (http://localhost/form.htm)
'P2 - No "Content-Type: " specified, this is the content type of the posted data
'     Posted data is found after the header, by itself, on a separate line, URL encoded (name=value&name2=value2).
'     Usually post data will be of the content type: application/x-www-form-urlencoded
'     This file is neccessary for the CGI interpreter to be able to grab the post data from
'     Standard Input, without this and Content-Length, the interpreter will fail
'P3 - No "Content-Length: " specified, this is the length of the post data for standard input
'     into the CGI interpreter. This is the number of bytes (or characters) on the line, not
'     including the last carriage returns. Example: name=test&password=test2 would be 24 bytes or
'     Content-Length: 24


End Function



Public Function Execute(Optional strTempDir As String) As String
'ok this is the execution function for the interpreter.
'up to this point, we have set the property "ServerSoftware" manually at load time
'The ServerSoftware property will become the env. variable "SERVER_SOFTWARE"
'The setHeader function has also parsed the POST or GET request header and has setup these items
'ready for conversion into environment variables:
'strServer_Software - "SERVER_SOFTWARE"
'strServer_Name - "SERVER_NAME"
'strServer_Port - "SERVER_PORT"
'strRequest_Method - "REQUEST_METHOD"
'strScript_Name - "SCRIPT_NAME"
'strScript_Filename - "SCRIPT_FILENAME" (this was done in the setLocalFilePath function)
'strQuery_String - "QUERY_STRING"
'strRemote_Addr - "REMOTE_ADDR" (this was done in the setRemoteUserIP function)
'strHTTP_Referer - "HTTP_REFERER"
'strHTTP_User_Agent - "HTTP_USER_AGENT"
'strContent_Length - "CONTENT_LENGTH" (only used in the POST request method)
'strContent_Type - "CONTENT_TYPE" (only used in the POST request method)
'strHTTP_Cookie - "HTTP_COOKIE"

'NOTE: REQUEST_METHOD, CONTENT_LENGTH, and CONTENT_TYPE have to be set last, in that order
'for it to work correctly.

'ok... So far everything has been nice and straight forward. What we're about to do is not so nice.
'Environment Variables only work in a single process. Once a process is started (say a process of command.com or cmd.exe)
'the environment variable can be set, but it's only good until you have closed that process.
'You can have multiple processes running with the same environment variable in each process with
'a different value. Say I have 2 command prompt screens open, I can set QUERY_STRING in one window
'to a certain value, and set QUERY_STRING in the other window to a different value, and they will not affect
'each other.
'What am I getting at? Good question.
'You see, VB cannot execute a command line function and simply "PASS" environment variables to it.
'They have to be set first, by using the command (for example): "set QUERY_STRING=name=value"
'I know it looks funny, but that's how the command line knows what you are saying, you can't use
'quotations around your name/value pairs, it won't get set. Now here's a big question: I see that
'I can set one set of name/value pairs, but when I use the ampersand (&) to make 2 pairs, I get a
'"not recognized as an internal or external command, operable program or batch file" error.
'Good observation... The ampersand is a special character reserved by the command line interface
'for miscellaneous use, as a divider of data. To get around this, use the command line escape
'character (^) before the ampersand (for example): "set QUERY_STRING=name=value^&name2=value2"
'and it works!!!
'ALSO, the percent sign is another type of escape character, to remove the character following it
'so to get around that, we'll have to place another percent sign infront of it to keep the next character
'from getting removed, I know it sounds like it wouldn't work, but it does.
'OK now that we're past how to set environment variables, what are we talking about?
'Good question...
'Since we can't just start a cmd.exe process and start throwing commands in there and grabbing data
'off the screen, all the while providing standard input for the CGI interpreter, we have to create
'a .BAT (or BATCH) file. A .bat file is basically a set of instructions to run on a command line
'whenever it is executed.
'Here's my point, we have to create, on they fly, in a temporary directory on the hard hard (so your
'webserver can be run off of a cd perhaps), a "dos batch file", with all these commands in it.

'Ok, so here's the process of what is going on in this function:

'FIRST we need to find a temporary directory to put files in. We have given the option of
'passing a temporary directory from the webserver softare (strTempDir). If one is not passed, or we cannot write
'to that directory, we will find the current user's temporary directory by using Environ$("temp").
'Environ$("temp") calles the system variable "temp" and we find the users temp directory...

'Once we have a temporary directory picked out, we have to generate 2 files, one is the DOS Batch File,
'the other is the standard input file. The standard input file is for data sent during a POST request.
'It is formatted the same way as QUERY_STRING (but without the dos escape character).
'Example of a standard input file: "name=value&name=value2&password=whatever", and that is the only thing
'that will be in the standard input file.

'NOTE: all data in the standard input file and the QUERY_STRING env. var have to be URL encoded, which
'should have been done by the user's browser, BUT keep in mind, that the browser will use percent signs
'to url-encode data, we'll have to replace these percent signs with 2 percent signs later.

'When we generate this file, we will use a .tmp file extension, that way if the file is not deleted after use,
'the user's windows cleanup process will remove it.

'These 2 files are going to have random file names that will be generated here, this is so that if there are
'2 processes that get run at the same time, one user will not see the other user's interpreted script.
'If a file exists with that name already, we simply generate a different random filename and try again.
'These 2 files will have the same filename but with different extesions, one being .TMP and the other .BAT
'For example: 02876494739373.tmp and 02876494739373.bat. The .tmp file will serve as our standard input
'before the interpreter is ran

'After the interpreter is ran, you might ask "why don't we just pipe the output data back to a file and
'send the filename back to the webserver?".
'Good question there also, originally I had planned to do that, to keep from passing huge amounts of data
'back and forth between the DLL and the webserver. BUT the interpreter would end and the execute function
'would be done before the output file was even created. SO, instead of putting a timer on things and risk
'looping to infinity, we'll just grab the output data off of the screen, clean it, and send it back to the
'webserver as a string. I know this is dirty, but I said that from the start...

'Once the webserver has sent that data back to the user, the webserver will call the
'"EndMission" function and pass it the path of the interpreted file. The "EndMission" function
'basically just deletes the file, that keeps the webserver from having to do too much at once.


'now on with the function

'initialize our filesystemobject variable
Set fs = New Scripting.FileSystemObject


Dim strTempDirectory As String
'first we determine the temporary directory:
strTempDirectory = strTempDir


'this is our loopback point, incase we can't get a good temp directory on the first try
'if we can't, we'll check to see if we're using the user's temp directory, if not
'we'll try that, if that folder doesn't exist, or we can't write to it, we need to abort the function
'and return and error code explaining why.
Reassign:

    If strTempDirectory = "" Then
    'if no temporary directory was passed, then use the current user's temporary directory
        strTempDirectory = Environ$("temp")
    
    End If
    
    
'now we check to make sure there is a backslash on the end
    If Not Right(strTempDirectory, 1) = "\" Then
    'if there's not one, add one
    strTempDirectory = strTempDirectory & "\"
    End If
    
    'now we check to see if we have write access to this directory
    'we have to use the MS FileSystem Scripting Object to do this and
    'to create the file
    'so it is referenced in with this project
    
    
    If (Not fs.GetFolder(strTempDirectory).Attributes = 22) And fs.FolderExists(strTempDirectory) Then
    'this is a good folder, we can use it
    
    
    'do nothing here, just keep going
    
    Else
    'the directory either doesn't exist, or we can't write to it, on the first try, we'll try to
    'use the user's temp directory and try again, if that doesn't work, abort and error out.
    
    
        If Not strTempDirectory = Environ$("temp") Then
        'we're not using the system's temp folder
        'let's reassign it to the system temp folder and retry
            strTempDirectory = ""
            GoTo Reassign
    
        Else
        'the folder path passed was bad, or none was passed and the system temp folder is bad
        
        Execute = "T1,"
        Exit Function
        
        
        End If
        
    
    End If




'ok, if we are this point we have a usable temp directory, we need to generate a temporary file now
Dim strTempFile As String, strTempFilePath As String

'here is our loopback point for generating a temporary filename, if the filename we have chosen already
'exists, we will loopback to here, generate another filename and try again.
RetryFile:

    strTempFile = GenNum & ".tmp"
    
    'now we have a temporary file name, we need to check to see if it's in use, we will loop this
    'until we have a temporary filename that doesn't exist
    'This can take forever if you don't call EndMission after you send the data back to the user
    'because all of the old files will remain in place. If the webserver is restart, the
    'random numbers will have the same sequence, and hence the new random numbers will have the same
    'sequence as the files already in place.
    'Cannot stress enough, you MUST CALL "EndMission"
    
    
    'ok, put the directory and file together and check for existence
    strTempFilePath = strTempDirectory & strTempFile
    
        If fs.FileExists(strTempFilePath) = True Or fs.FileExists(Replace(strTempFilePath, ".tmp", ".bat")) = True Then
        'either the .tmp file or the .bat file exists, we need to try again
        GoTo RetryFile
        
        End If
        
        
        
    'ok, we have a temporary directory, and a good temporary filename, let's do this thing:
    
    Open strTempFilePath For Output As #1
    'open the tmp file for output
    'here we'll place the POST data for Standard input (and URL encode it)
    'we have the POST data in the global variable strPost_Data from the "SetHeader" function
    Print #1, strPost_Data
    'and close the file
    Close #1
    
    'now we need to write the .bat file
    'replace .tmp with .bat in the filepath
    strTempFilePath = Replace(strTempFilePath, ".tmp", ".bat")
    
    'ok, here we have to write the information to set the environment variables and
    'execute our CGI interpreter with the standard input, and dump it out to the .tmp file
    
    'first we'll open the file for output and setup the environment variables
    Open strTempFilePath For Output As #1
    
    Print #1, "set SERVER_SOFTWARE=" & strServer_Software
    Print #1, "set SERVER_NAME=" & strServer_Name
    Print #1, "set GATEWAY_INTERFACE=" & strGateway_Interface
    Print #1, "set SERVER_PROTOCOL=" & strServer_Protocol
    Print #1, "set SERVER_PORT=" & strServer_Port
    Print #1, "set SCRIPT_NAME=" & strScript_Name
    Print #1, "set SCRIPT_FILENAME=" & strScript_Filename
    Print #1, "set REMOTE_ADDR=" & strRemote_Addr
    Print #1, "set HTTP_REFERER=" & Replace(Trim(strHTTP_Referer), "&", "^&")
    Print #1, "set HTTP_USER_AGENT=" & strHTTP_User_Agent
    Print #1, "set QUERY_STRING=" & Replace(Replace(Trim(strQuery_String), "&", "^&"), "%", "%%") 'url-encode the query string
    Print #1, "set HTTP_COOKIE=" & Replace(Replace(Trim(strHTTP_Cookie), "&", "^&"), "%", "%%")
    Print #1, "set HTTP_HOST=" & strHTTP_Host
  
    'now we need to determine whether this was a POST or GET request, this is important because
    'if it was a POSt we need to include the env. vars. CONTENT_LENGTH and CONTENT_TYPE
        If strRequest_Method = "POST" Then
        'we are in a post method, put in content_length and content_type
            Print #1, "set REQUEST_METHOD=" & strRequest_Method
            Print #1, "set CONTENT_LENGTH=" & strContent_Length
            Print #1, "set CONTENT_TYPE=" & strContent_Type
        Else
        'we are in a get method, leave out content_length and content_type
            Print #1, "set REQUEST_METHOD=" & strRequest_Method
        End If
        
    'now we put in our call to the interpreter using the tmp file as standard input
    'and piping the interpreted data back out to the screen for grabbing
    
    'we have to find out which interpreter to use
    
    Dim strInterpreter As String
    
    For i = 0 To intHandlerCount - 1
    

        If InStr(1, UCase(strScript_Name), UCase(strFileExt(i))) > 0 Then
        'we found the interpreter, set it and exit the loop
        strInterpreter = strFileHandler(i)
        Exit For
        End If
        
    Next i
    

    
    'ok, we have to put the data in the file in this format:
    'type inputfilepath | interpeterfilepath
    'remember, we're not piping the data out to a file, it may not get created before this function
    'has ended, we just wait on the interpeter to finish and then move on, sometimes it takes a second
    'before the files are created from the interpeter, so we'll just grab the data from the screen.
    'the interpreter will not exit until the data is completely displayed
    
    'also we need to surround the input file and the interpreter with quotes 'chr(34)' to elminate errors caused from spacing in
    'file paths
    Print #1, "type " & Chr(34) & Replace(strTempFilePath, ".bat", ".tmp") & Chr(34) & " | " & Chr(34) & strInterpreter & Chr(34)
    
    Close #1
    
    
    
    
    
    'now we need to execute the .bat file and wait for it to finish
    'it will wait for the interpeter to finish before it closes
    
    
    'this is the variable that will eventually contain error information or outputted code
    Dim strReturn As String
    
        
    'ok, we execute the .bat file with our input (stdin) file path and wait for it to finish
    'we also grab any output and return it to strReturn
    strReturn = ExecuteApp(strTempFilePath)

    'ok now we need to clean strReturn and remove the code for setting the env. vars. and
    'the piping command for the interpreter, the second variable is to tell the CleanReturn
    'function where to start cleaning, in this case, the last thing we put in the .bat file
    'was the path of the interpreter surrounded with quoation marks, so we'll tell it to start
    'grabbing there.
    strReturn = CleanReturn(strReturn, strInterpreter)
    
    
    'ok, data is clean, ready to be returned to whatever called this function
    Execute = strReturn
    


    'now we will delte the files we used for setting the environment variables and running the interpreter
    'as well as the file generated to hold the standard input (stdin)
    Kill strTempFilePath
    Kill Replace(strTempFilePath, ".bat", ".tmp")
    

    


'de-initialize fs back to nothing
Set fs = Nothing




'Error Codes:
'T1 - Bad system temp folder
'any other erros, for example, from the interpreter, will be returned "as is"

End Function


Private Function CleanReturn(strReturn As String, strCapturePoint As String) As String
'this function cleans up the return data captures from our temporary batch file
'since we have captured everything on the screen, we have also captured the
'commands we have run to set the environment variables and the command to run the interpreter
'with stdin. We have to clean out that data to get just the output from the interpreter
'the strCapturePoint variable is the last thing that was run from the command line
'which would be the path of the interpreter, with a quotation mark on the end, so
'we find the path of the command line, and store it as intStart, then we get everything to
'the right of that minus 2 bytes (the quotation mark and the carriage return)

Dim intStart As Integer

intStart = InStr(1, strReturn, strCapturePoint) + Len(strCapturePoint)

CleanReturn = Right(strReturn, Len(strReturn) - intStart - 2)



End Function



Public Function setRemoteUserIP(strData2 As String) As String

'this function is used to set the remote user IP, it stores the IP to
'strRemote_Addr which is used as an environment variable in the Execute function
'we will check the IP for validity (4 sets of numbers separated by 3 periods, and all less than
'255 and greater than 0, we also set bolRemote_Addr = true so that our Execute function
'knows that this function has been run

Dim strIPParts() As String

    strIPParts = Split(strData2, ".")
    
    If Not UBound(strIPParts) = 3 Then
    setRemoteUserIP = "E1,"
    Exit Function
    End If
    
    For i = 0 To 3
    
        If Not (CInt(strIPParts(i)) <= 254 And CInt(strIPParts(i)) >= 0) Then
        setRemoteUserIP = "E1,"
        Exit Function
        End If
    
    Next i


    strRemote_Addr = strData2
    bolRemote_Addr = True
    
'Error Codes:
'E1 - Invalid IP Address
End Function

Public Function setLocalFilePath(strData2 As String) As String
'this function is used to set the local path of the script file
'we make sure it is a valid path, if not return an error code
'then set bolScript_Filename = True so that the Execute function
'knows that have run this function

    If InStr(1, strData2, ":\") <= 0 Then
    setLocalFilePath = "E1,"
    Exit Function
    
    End If
    
    
    strScript_Filename = strData2
    bolScript_Filename = True
    

    
'Error codes:
'E1 - Not actual file path on local system given

End Function





Private Function GenNum() As String
'this function just generates a random 10 digit number and returns it as a string
'some of this code is borrowed from planet-source-code.com


Dim strRandNum As String
Dim intRandNum(100) As Integer
Dim i, j, intTemp1 As Integer
Dim bolStop As Boolean


i = 2

intRandNum(1) = Int((100 * Rnd) + 1)

Do While i < 101

    j = 1
    bolStop = False
    intTemp1 = Int((100 * Rnd) + 1)

    Do While j < i And bolStop = False

        If intRandNum(j) = intTemp1 Then
            bolStop = True
        End If

        j = j + 1

    Loop

        If bolStop = False Then

            intRandNum(i) = intTemp1
    
            i = i + 1
        End If

Loop



For i = 0 To 4

    strRandNum = strRandNum & CStr(intRandNum(i + 1))

Next i

GenNum = strRandNum

End Function
















'order of execution for this DLL:
'AT LOAD TIME, SET THIS PROPERTY
'ServerSoftware - software's name and version (formatted as: softwarename/1.0)
'AND RUN THIS FUNCTION
'setHandlers - this function is used to tell this DLL which interpreters will be used for
'              which file extensions

'THESE FUNCTIONS MUST BE EXECUTED PRIOR TO RUNNING THE EXECUTE FUNCTION!!!
'SetLocalFilePath - just pass it the file path of the script file on the machine (c:\folder\script.php)
'   if there is an error, the function will stop and produce a lettered error code, no warnings
'SetRemoteUserIP - pass it the ip address of the user requesting the script, in a string format.
'   if there is an error, the function will return it, the only error so far is for a bad IP
'SetHeader - just pass it the entire request header as a string
'   if there is an error, the function will stop and produce a lettered error code, if multiple
'   errors, there will be multiple codes (ex: A1,F1,P3), there are warnings. If a warning is present
'   function will continue to run and warning codes will be generated (ex: W2,W3)

'And finally execute the process, grab the data and return it
'Execute - runs all the data


